package org.openxma.dsl.pom.util;

import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.openxma.dsl.common.extensions.EObjectPropertiesAdapter;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.StylePropertyCharacterWidth;
import org.openxma.dsl.pom.model.StyleSpecification;
import org.openxma.dsl.pom.model.StyleSpecificationProperty;

public class StyleAccess {
    
    private static final String COMBINED_STYLE_NAME = "combinedStyle";
    
    public static void setCombinedStyleProperty(EObject obj, Map<Integer,StyleSpecificationProperty> combinedStyleSpecificationProperties) {
        EObjectPropertiesAdapter.setProperty(obj,COMBINED_STYLE_NAME,combinedStyleSpecificationProperties);
    }
    
    @SuppressWarnings("unchecked")
    public static Map<Integer,StyleSpecificationProperty> getCombinedStyleProperty(EObject obj) {
        Object value = EObjectPropertiesAdapter.getProperty(obj,COMBINED_STYLE_NAME);
        if (value instanceof Map<?,?> || value == null) {
            return (Map<Integer,StyleSpecificationProperty>)value;
        }
        throw new RuntimeException("The property '"+COMBINED_STYLE_NAME+"' is not of type 'Map<Integer,StyleSpecificationProperty>'");
    }
    
    
    
    public static StyleSpecificationProperty getStyleProperty(Map<Integer,StyleSpecificationProperty> styleProperties, int idStyle) {
        if (styleProperties != null) {
            return (StyleSpecificationProperty)styleProperties.get(idStyle);
        }
        return null;
    }    
    
    public static StylePropertyCharacterWidth getCharacterWidthStyle(Map<Integer,StyleSpecificationProperty> styleProperties) {
        return (StylePropertyCharacterWidth)getStyleProperty(styleProperties,PomPackage.STYLE_PROPERTY_CHARACTER_WIDTH);
    }    

}
